Saltar al contenido

Comentar Imagen

Foto

extraer coordenadas a excel


  • Please log in to reply
4 Respuesta(s) a este Tema

#1
sendadiego

sendadiego

    Experto en AuxCAD

  • Miembros
  • 62 Mensajes
  • Auxis: 2

    Hola, no tengo ni idea de macros (me encantaría) y tengo un problema que me pasa muy a menudo.

     

    Mi problema es el siguiente, para programar taladros en una maquina de cnc no lo hacemos de forma manual si no que insertamos un excel con las coordenadas en la maquina y listo (evita errores humanos), el problema es que cuando uso catia no puedo exportar a un fichero txt o excel dichas coordenadas.

     

    ¿se podría hacer de alguna forma esto? da igual que sean puntos de 3d o de 2d la cosa es sacar unos puntos en formato excel.

     

    Espero vuestra ayuda.

     

    Gracias de antemano.


    • 0

    #2
    ferdo

    ferdo

      Experto en AuxCAD

    • Miembros
    • 215 Mensajes
  • Auxis: 104
    • Pais: Country Flag
    Sub CATMain()
    
    
    Dim oPartDoc As Part
    On Error Resume Next
    Set oPartDoc = CATIA.ActiveDocument.Part 
    If Err.Number <> 0 Then  
    Message = MsgBox("Sorry, This script works with a CATPart as Active document", vbCritical, "Error")
    Exit Sub
    End If
    ' What do want to select
    Dim EnableSelectionFor(0)
      EnableSelectionFor(0) = "HybridBody"
    ' Reset the Selection
    Set sSEL = CATIA.ActiveDocument.Selection
      sSEL.Clear
    ' Define Selection
      MsgBox "Please Select the Geometrical Set where are the points for extracting"
      UserSelection = sSEL.SelectElement2(EnableSelectionFor, "Please select an another Geometrical Set", False)
    ' Evaluation if the selectio is correct or not
    If UserSelection <> "Normal" Then
          MsgBox "Error with the selection"
        Exit Sub
    Else
    Set ohybridbody = sSEL.Item(1).Value
      MsgBox "The Geometrical Set selected is : " & ohybridbody.Name
    End If
    ReDim acoord(2)
    '--------------------------------------------------------------------------------
    '   The location of the result file
    '--------------------------------------------------------------------------------
    Dim filename As String
    filename = CATIA.FileSelectionBox("Where do you want to save the result file", "*.txt", CatFileSelectionModeSave)
    Set Datos = CATIA.FileSystem.CreateFile(filename & ".txt" , True)
    Set ostream = Datos.OpenAsTextStream("ForAppending")
    ostream.Write ("Points Extraction from " & oPartDoc.Name & ".CATPart" & Chr(10))
    ostream.Write (" "& Chr(10))
    ostream.Write ("The selected Geometrical Set was : " & ohybridbody.Name & Chr(10))
    ostream.Write (" "& Chr(10))
    Set oshapes = ohybridbody.HybridShapes
    For i = 1 To oshapes.Count
    oshapes.Item(i).GetCoordinates acoord
    Set reference1 = oshapes.Item(i)
    ostream.Write (reference1.Name & Chr(10))
    ostream.Write ("X" & acoord(0) & "Y" & acoord(1) & "Z" & acoord(2) & Chr(10))
    Next
    ostream.Close
    MsgBox "Points Exported :" & (i-1) & "x" & Chr(10) & Chr(10) & "Please Check the following file for result : " &  chr(10) &  chr(10) & filename &  chr(10)&  chr(10) & "Process finished"
    End Sub
    
    

    • 2
    Un saludo cordial
    Fernando

    sites visited in RO
    sites visited in EU

    #3
    sendadiego

    sendadiego

      Experto en AuxCAD

    • Miembros
    • 62 Mensajes
  • Auxis: 2

    me da error no se porque, podriais ayudarme?

     

    Gracias


    • 0

    #4
    ferdo

    ferdo

      Experto en AuxCAD

    • Miembros
    • 215 Mensajes
  • Auxis: 104
    • Pais: Country Flag

    ¿Qué tipo de error?
    Macro está funcionando bien en ordenadores con configuración regional en Inglés y CATIA en Inglés.


    • 0
    Un saludo cordial
    Fernando

    sites visited in RO
    sites visited in EU

    #5
    sendadiego

    sendadiego

      Experto en AuxCAD

    • Miembros
    • 62 Mensajes
  • Auxis: 2

    Como de error de diseño


    • 0




    0 Usuario(s) están leyendo este Tema

    0 miembro(s), 0 invitado(s), 0 usuario(s) anónimo(s)